#include "ConnectivityManager.h"

ConnectivityManager::ConnectivityManager() : _error(0), _sdCardManager(NULL)
{
  persistent(false);
  
  if(!enableSTAAndAP(false))_error &= AP_AND_STA_ENABLED_ERR;
  if(!softAP("ESP8266SwissArmyBoard", NULL, 1, false, 8))_error &= AP_SETUP_ERR;
}

ConnectivityManager::ConnectivityManager(SDCardManager *sdCardManager) : _error(0), _sdCardManager(sdCardManager)
{
  persistent(false);
  if(!enableSTAAndAP(false))_error &= AP_AND_STA_ENABLED_ERR;
  else
  {
    CFGFileParser cfgFileParser(*sdCardManager, AP_CFG_FILE);
    CFGDictionary<CFGParameterValue> *cfgDictionary = (CFGDictionary<CFGParameterValue> *) cfgFileParser.parseFile();
    if(cfgDictionary == NULL)
    {
      if(!softAP("ESP8266SwissArmyBoard", NULL, 1, false, 8))_error &= AP_SETUP_ERR;
    }
    else
    {
      if(!softAP((*cfgDictionary)("SSID").getValue().stringValue(), strcmp((*cfgDictionary)("PASSWORD").getValue().stringValue(),"") == 0 ? NULL:(*cfgDictionary)("PASSWORD").getValue().stringValue(), (*cfgDictionary)("CHANNEL").getValue().intValue(), (*cfgDictionary)("SSID_HIDDEN").getValue().booleanValue(), (*cfgDictionary)("AP_MAX_CONNECTION").getValue().intValue()))_error &= AP_SETUP_ERR;
      delete cfgDictionary;
    }
    
    CFGFileParser cfgFileParserSTA(*sdCardManager, STA_CFG_FILE);
    cfgDictionary = (CFGDictionary<CFGParameterValue> *) cfgFileParserSTA.parseFile();
    if(cfgDictionary != NULL)
    {
      if(!begin((*cfgDictionary)("SSID").getValue().stringValue(), (*cfgDictionary)("PASSWORD").getValue().stringValue()))_error &= AP_SETUP_ERR;
      delete cfgDictionary;
    }
  }
}

boolean ConnectivityManager::enableSTAAndAP(boolean enabled)
{
  return enableSTA(enabled) && enableAP(enabled);
}

unsigned char ConnectivityManager::getError() const
{
  return _error;
}

